#!/usr/bin/perl -w
use strict;
use warnings;

while (@ARGV)
{
    my $f = shift;
    if (-e $f)
    {
	my $o = $f.'.i2b';
	if ($f =~ /^(\w+)\.w+$/)
	{
	    $o = $1.'.i2b';
	}
	open MYIN ,'<',$f or die "Could not open file $f for reading $!\n";
	my $found = 0;
	my ($date,$time);
	while (!$found && !eof(MYIN))
	{
	    my $st = <MYIN>;
	    $found = 1 if ($st =~ /^[\s\t\#]*ZCURVE/);
	    if ($st =~ /^[\s\t\#]*DATE[\s\t]+LABEL[\s\t]+([\w\-]+)/)
	    {
		$date = $1;
	    }
	    if ($st =~ /^[\s\t\#]*TIME[\s\t]+LABEL[\s\t]+([\d\:]+)/)
	    {
		$time = $1;
	    }
	}
	my $timestr;
	if ($date && $time)
	{
	    my @d = split(/\-/,$date);
	    my @t = split(/\:/,$time);
	    foreach (@d,@t)
	    {
		$_ += 0;
		$_ = '0'.$_ if ($_ < 10);
	    }
	    $timestr = ':'.$d[2].':'.$d[1].':'.$d[0].':'.join(':',@t);
	    <MYIN>;
	    <MYIN>;
	    my @data = ();
	    while (<MYIN>)
	    {
		push @data,$_ if /\w/;
	    }
	    open MYOUT,'>',$o or die "Coould not open file $o for writing $!\n";
	    print MYOUT "\n\n";
	    print MYOUT $timestr,"\n\n\n\n";
	    print MYOUT scalar(@data),"\n";
	    foreach my $s (@data)
	    {
		my @l = split(/[\s\t]+/,$s);
		print MYOUT "$l[3]\t$l[4]\t$l[5]\n";
	    }
	    close MYOUT;
	}
	close MYIN;
    }
}
