#!/usr/bin/perl -T
use strict;
use warnings;
use Impedance::Header;
use Impedance::Model;
use Impedance::IMPCGI qw(:html :cgi);
use CGI qw(:standard :netscape);
&print_header("Elchemea analytical",-onBlur=>'initiateSelfClosing()');
my $model = Impedance::Model->new();
$model->data(param('data'));
my @data = split(/\n/,$model->data);
my $data2 = $model->data();
$data2 =~ s/\n/\%0A/g;
$data2 =~ s/\+/\%2B/g;
my $plotmode = param('plotmode');
$plotmode = 'Nyquist' unless ($plotmode);
my @arr = ();
my $maxf = 0;
my $minf = 1e100;
my $x = 0;
foreach (@data)
{
    if (/([\d\.eE\+\-]+)/)
    {
	push @arr,"arr[$x] = $1;";
	$maxf = $1 if ($1 > $maxf);
	$minf = $1 if ($1 < $minf);
	$x++;
    }
}
my $arrstr = join("\n",@arr);
my $file = SemaforeFile->new('/tmp/delete_'.$$.'.gp');
my $file2 = SemaforeFile->new('/tmp/bode_'.$$.'.gp');
my $pngfn = $pngdir.'delete_'.$$.'.png';
my $pngb = $pngdir.'bode_delete_'.$$.'.png';
$file->writeline($Impedance::Header::gpheader);
$file->append("set out '$pngfn'");
$file->append("set title 'Select data point to delete'");
$file2->writeline($Impedance::Header::gpheader);
$file2->append("set out '$pngb'");
$file2->append("set title 'Select data point to delete'");
my @l = $model->print_plot;
my @l2 = $model->print_bode;
my $dfile = SemaforeFile->new('/tmp/delete_dat'.$$.'.dat');
my @d2 = split(/\n/,$model->data());
$dfile->writeline($d2[0]);
my $impplot = pop(@l);
my $bodeplot = pop(@l2);;
$impplot .= ", '".$dfile->filename."' u 2:(-\$3) w p pt 4 tit 'F'";
$bodeplot .= ", '".$dfile->filename."' u 1:(abs(\$2)) w p pt 4 tit 'F','' u 1:(abs(\$3)) w p pt 4 tit 'F'";
$file->append(@l,$impplot);
$file2->append(@l2,$bodeplot);
eval {
    system('/usr/bin/gnuplot '.$file->filename);
    system('/usr/bin/gnuplot '.$file2->filename);
};
if ($@)
{
    print h3({-class=>'Alert'},$@);
}
if ($plotmode && $plotmode =~ /bode/i)
{
    print '<center><img name="simulation" src="/analytic/png/bode_delete_'.$$.'.png" id="simulation"></center>';
}
else
{
    print '<center><img name="simulation" src="/analytic/png/delete_'.$$.'.png" id="simulation"></center>';
}
unlink $file->filename if ($file->exist);
unlink $file2->filename if ($file2->exist);
unlink $dfile->filename if ($dfile->exist);
print '<center><table border=0 cellspacing=10>';
if ($plotmode =~ /bode/i)
{
    print '<tr><td>';
    print button(-name=>'l30',-value=>'<<x30',-class=>'s3',-onclick=>'set_f(f+30)');
    print '</td><td>';
    print button(-name=>'l10',-value=>'<<x10',-class=>'s3',-onclick=>'set_f(f+10)');
    print '</td><td>';
    print button(-name=>'l5',-value=>'<<x3',-class=>'s3',-onclick=>'set_f(f+3)');
    print '</td><td>';
    print button(-name=>'l',-value=>'<',-class=>'s3',-onclick=>'set_f(f+1)');
    print '</td><td>';
    print button(-name=>'ok',-value=>'Delete',-class=>'s0',-onclick=>'set_ok();');
    print '</td><td>';
    print button(-name=>'r',-value=>'>',-class=>'s3',-onclick=>'set_f(f-1)');
    print '</td><td>';
    print button(-name=>'r5',-value=>'>>x3',-class=>'s3',-onclick=>'set_f(f-3)');
    print '</td><td>';
    print button(-name=>'r10',-value=>'>>x10',-class=>'s3',-onclick=>'set_f(f-10)');
    print '</td><td>';
    print button(-name=>'r30',-value=>'>>x30',-class=>'s3',-onclick=>'set_f(f-30)');
    print '</td></tr>';
}
else
{
    print '<tr><td>';
    print button(-name=>'l30',-value=>'<<x30',-class=>'s3',-onclick=>'set_f(f-30)');
    print '</td><td>';
    print button(-name=>'l10',-value=>'<<x10',-class=>'s3',-onclick=>'set_f(f-10)');
    print '</td><td>';
    print button(-name=>'l5',-value=>'<<x3',-class=>'s3',-onclick=>'set_f(f-3)');
    print '</td><td>';
    print button(-name=>'l',-value=>'<',-class=>'s3',-onclick=>'set_f(f-1)');
    print '</td><td>';
    print button(-name=>'ok',-value=>'Delete',-class=>'s0',-onclick=>'set_ok();');
    print '</td><td>';
    print button(-name=>'r',-value=>'>',-class=>'s3',-onclick=>'set_f(f+1)');
    print '</td><td>';
    print button(-name=>'r5',-value=>'>>x3',-class=>'s3',-onclick=>'set_f(f+3)');
    print '</td><td>';
    print button(-name=>'r10',-value=>'>>x10',-class=>'s3',-onclick=>'set_f(f+10)');
    print '</td><td>';
    print button(-name=>'r30',-value=>'>>x30',-class=>'s3',-onclick=>'set_f(f+30)');
    print '</td></tr>';
}
print '<tr><td colspan=3></td><td colspan=3>';
print button(-id=>'action_btn',-name=>'test',-class=>'s5',-value=>'OK',-onclick=>'return_to_caller()');
end_top_bar();
print '</center>';

print <<END;

<script language="javascript">

var f = 0;
var maxf = 0;
var minf = 0;
var sumf = 0;
var d = '$data2';
var arr = new Array;
$arrstr

var maxid = arr.length-1;

function return_to_caller()
{
    opener.document.sofc.data.value = document.sofc.data.value;
    opener.document.sofc.allow_close.value = 1;
    opener.add_element("");
    self.close();
}

function set_ok()
{
    if (!confirm("Delete point"))
    {
	return false;
    }
    var d = document.sofc.data.value;
    var query = "&action=delete_point&f="+f+"&data="+d+"&plotmode="+document.sofc.plotmode.value;
    query = query.replace(/\\n/g,"%0A");
    query = query.replace(/\\+/g,"%2B");
    run_ajax('ajax_model.cgi',query,set_delete);
}

function set_delete(res)
{
    var out = res.split("\\n");
    if (out[0] != "OK")
    {
        alert(res);
        return false;
    }
    var ok = out.shift();
    maxid = out.length-2;
    document.sofc.data.value = out.join("\\n");
    opener.document.sofc.data.value = document.sofc.data.value;
    opener.add_element("");
    set_f(f);
}

function set_f(e)
{
    f = e;
    if (f < 0)
	f = 0;
    if (f >= maxid)
	f = maxid;
    var d = document.sofc.data.value;
    var query = "&action=select_points_delete&f="+f+"&data="+d+"&plotmode="+document.sofc.plotmode.value;
    query = query.replace(/\\n/g,"%0A");
    query = query.replace(/\\+/g,"%2B");
    run_ajax('ajax_model.cgi',query,set_img);
}

function set_img(res)
{
    var out = res.split("\\n");
    if (out[0] != "OK")
    {
        alert(res);
        return false;
    }
    var img = document.getElementById("simulation");
    img.src = out[1] + "?" + Math.random();
}

</script>

END


    print end_html();
exit;

